#define FILE_WRITE 0x1
#define FILE_READ 0x2
#define FILE_APPEND 0x4
#define INIT_TIME 0x1
#define INIT_AUDIO 0x2
#define INIT_DISPLAY 0x4
#define INIT_INPUT 0x8
#define INIT_CONTROLLER 0x10
#define INIT_HAPTIC 0x20
#define INIT_EVERYTHING 0x3f

#define DISPLAY_HIDDEN 0x1
#define DISPLAY_BORDERLESS 0x2
#define DISPLAY_RESIZABLE 0x4
#define DISPLAY_MINIMIZED 0x8
#define DISPLAY_MAXIMIZED 0x10
#define DISPLAY_FULLSCREEN 0x20
#define DISPLAY_VSYNC 0x40
#define DISPLAY_SOFTWARE_GRAPHICS 0x80

#define MESSAGE_BOX_ICON_INFO 0
#define MESSAGE_BOX_ICON_WARNING 1
#define MESSAGE_BOX_ICON_ERROR 2

#define ENUMS_THREAD_PRIORITY_LOW 0
#define ENUMS_THREAD_PRIORITY_NORMAL 1
#define ENUMS_THREAD_PRIORITY_HIGH 2

#define CONTROLLER_POWER_UNKNOWN 0
#define CONTROLLER_POWER_EMPTY 1
#define CONTROLLER_POWER_LOW 2
#define CONTROLLER_POWER_MEDIUM 3
#define CONTROLLER_POWER_FULL 4
#define CONTROLLER_POWER_WIRED 5
#define CONTROLLER_POWER_MAX 6

#define CURSOR_ARROW 0
#define CURSOR_IBEAM 1
#define CURSOR_WAIT 2
#define CURSOR_CROSSHAIR 3
#define CURSOR_WAITARROW 4
#define CURSOR_SIZENWSE 5
#define CURSOR_SIZENESW 6
#define CURSOR_SIZEWE 7
#define CURSOR_SIZENS 8
#define CURSOR_SIZEALL 9
#define CURSOR_NO 10
#define CURSOR_HAND 11
#define CURSOR_NUM 12

#define KEY_NONE 0
#define KEY_ANY 1
#define KEY_A 2
#define KEY_B 3
#define KEY_C 4
#define KEY_D 5
#define KEY_E 6
#define KEY_F 7
#define KEY_G 8
#define KEY_H 9
#define KEY_I 10
#define KEY_J 11
#define KEY_K 12
#define KEY_L 13
#define KEY_M 14
#define KEY_N 15
#define KEY_O 16
#define KEY_P 17
#define KEY_Q 18
#define KEY_R 19
#define KEY_S 20
#define KEY_T 21
#define KEY_U 22
#define KEY_V 23
#define KEY_W 24
#define KEY_X 25
#define KEY_Y 26
#define KEY_Z 27
#define KEY_NUM0 28
#define KEY_NUM1 29
#define KEY_NUM2 30
#define KEY_NUM3 31
#define KEY_NUM4 32
#define KEY_NUM5 33
#define KEY_NUM6 34
#define KEY_NUM7 35
#define KEY_NUM8 36
#define KEY_NUM9 37
#define KEY_LEFT 38
#define KEY_RIGHT 39
#define KEY_UP 40
#define KEY_DOWN 41
#define KEY_SPACE 42
#define KEY_ENTER 43
#define KEY_BACKSPACE 44
#define KEY_TAB 45
#define KEY_ESCAPE 46
#define KEY_CONTROL 47
#define KEY_SHIFT 48
#define KEY_ALT 49
#define KEY_SUPER 50
#define KEY_LCONTROL 51
#define KEY_LSHIFT 52
#define KEY_LALT 53
#define KEY_LSUPER 54
#define KEY_RCONTROL 55
#define KEY_RSHIFT 56
#define KEY_RALT 57
#define KEY_RSUPER 58
#define KEY_MENU 59
#define KEY_LBRACKET 60
#define KEY_RBRACKET 61
#define KEY_SEMICOLON 62
#define KEY_COMMA 63
#define KEY_PERIOD 64
#define KEY_QUOTE 65
#define KEY_SLASH 66
#define KEY_BACKSLASH 67
#define KEY_TILDE 68
#define KEY_EQUAL 69
#define KEY_HYPHEN 70
#define KEY_CAPSLOCK 71
#define KEY_NUMLOCK 72
#define KEY_PRINTSCREEN 73
#define KEY_PAGE_UP 74
#define KEY_PAGE_DOWN 75
#define KEY_HOME 76
#define KEY_END 77
#define KEY_INSERT 78
#define KEY_DELETE 79
#define KEY_ADD 80
#define KEY_SUBTRACT 81
#define KEY_MULTIPLY 82
#define KEY_DIVIDE 83
#define KEY_NUMPAD0 84
#define KEY_NUMPAD1 85
#define KEY_NUMPAD2 86
#define KEY_NUMPAD3 87
#define KEY_NUMPAD4 88
#define KEY_NUMPAD5 89
#define KEY_NUMPAD6 90
#define KEY_NUMPAD7 91
#define KEY_NUMPAD8 92
#define KEY_NUMPAD9 93
#define KEY_NUMPAD_PERIOD 94
#define KEY_NUMPAD_ENTER 95
#define KEY_F1 96
#define KEY_F2 97
#define KEY_F3 98
#define KEY_F4 99
#define KEY_F5 100
#define KEY_F6 101
#define KEY_F7 102
#define KEY_F8 103
#define KEY_F9 104
#define KEY_F10 105
#define KEY_F11 106
#define KEY_F12 107
#define KEY_NUM 108

#define MOUSE_BUTTON_NONE 0
#define MOUSE_BUTTON_ANY 1
#define MOUSE_BUTTON_LEFT 2
#define MOUSE_BUTTON_MIDDLE 3
#define MOUSE_BUTTON_RIGHT 4
#define MOUSE_BUTTON_NUM 5

#define MOUSE_FLAG_BUTTON_LEFT 0x1
#define MOUSE_FLAG_BUTTON_MIDDLE 0x2
#define MOUSE_FLAG_BUTTON_RIGHT 0x4

#define KEY_FLAG_CONTROL 0x1
#define KEY_FLAG_SHIFT 0x2
#define KEY_FLAG_ALT 0x4
#define KEY_FLAG_SUPER 0x8
#define KEY_FLAG_CAPSLOCK 0x10
#define KEY_FLAG_NUMLOCK 0x20

#define BLEND_EQUATION_ADD 0
#define BLEND_EQUATION_SUBTRACT 1
#define BLEND_EQUATION_REVERSE_SUBTRACT 2
#define BLEND_EQUATION_MIN 3
#define BLEND_EQUATION_MAX 4

#define BLEND_FACTOR_ZERO 0
#define BLEND_FACTOR_ONE 1
#define BLEND_FACTOR_SRC_COLOR 2
#define BLEND_FACTOR_SRC_ALPHA 3
#define BLEND_FACTOR_DST_COLOR 4
#define BLEND_FACTOR_DST_ALPHA 5
#define BLEND_FACTOR_CONSTANT_COLOR 6
#define BLEND_FACTOR_CONSTANT_ALPHA 7
#define BLEND_FACTOR_INV_SRC_COLOR 8
#define BLEND_FACTOR_INV_SRC_ALPHA 9
#define BLEND_FACTOR_INV_DST_COLOR 10
#define BLEND_FACTOR_INV_DST_ALPHA 11
#define BLEND_FACTOR_INV_CONSTANT_COLOR 12
#define BLEND_FACTOR_INV_CONSTANT_ALPHA 13

#define TEST_NEVER 0
#define TEST_ALWAYS 1
#define TEST_LESS 2
#define TEST_LESS_OR_EQUAL 3
#define TEST_GREATER 4
#define TEST_GREATER_OR_EQUAL 5
#define TEST_EQUAL 6
#define TEST_NOT_EQUAL 7
#define STENCIL_KEEP 0
#define STENCIL_ZERO 1
#define STENCIL_REPLACE 2
#define STENCIL_INCR 3
#define STENCIL_INCR_WRAP 4
#define STENCIL_DECR 5
#define STENCIL_DECR_WRAP 6
#define STENCIL_INVERT 7
#define DIR_CW 0
#define DIR_CCW 1
#define FACE_FRONT 0
#define FACE_BACK 1
#define FACE_FRONT_BACK 2

#define FORMAT_DEPTH16 0
#define FORMAT_DEPTH24 1
#define FORMAT_DEPTH32 2
#define FORMAT_DEPTH32F 3
#define FORMAT_STENCIL8 4
#define FORMAT_DEPTH24_STENCIL8 5
#define FORMAT_DEPTH32F_STENCIL8 6
#define FORMAT_R8 7
#define FORMAT_R16 8
#define FORMAT_RG8 9
#define FORMAT_RG16 10
#define FORMAT_RGB8 11
#define FORMAT_RGB16 12
#define FORMAT_RGBA8 13
#define FORMAT_RGBA16 14
#define FORMAT_R8S 15
#define FORMAT_R16S 16
#define FORMAT_RG8S 17
#define FORMAT_RG16S 18
#define FORMAT_RGB8S 19
#define FORMAT_RGB16S 20
#define FORMAT_RGBA8S 21
#define FORMAT_RGBA16S 22
#define FORMAT_R16F 23
#define FORMAT_R32F 24
#define FORMAT_RG16F 25
#define FORMAT_RG32F 26
#define FORMAT_RGB16F 27
#define FORMAT_RGB32F 28
#define FORMAT_RGBA16F 29
#define FORMAT_RGBA32F 30
#define FORMAT_R8I 31
#define FORMAT_R16I 32
#define FORMAT_R32I 33
#define FORMAT_RG8I 34
#define FORMAT_RG16I 35
#define FORMAT_RG32I 36
#define FORMAT_RGB8I 37
#define FORMAT_RGB16I 38
#define FORMAT_RGB32I 39
#define FORMAT_RGBA8I 40
#define FORMAT_RGBA16I 41
#define FORMAT_RGBA32I 42
#define FORMAT_R8Q 43
#define FORMAT_R16Q 44
#define FORMAT_R32Q 45
#define FORMAT_RG8Q 46
#define FORMAT_RG16Q 47
#define FORMAT_RG32Q 48
#define FORMAT_RGB8Q 49
#define FORMAT_RGB16Q 50
#define FORMAT_RGB32Q 51
#define FORMAT_RGBA8Q 52
#define FORMAT_RGBA16Q 53
#define FORMAT_RGBA32Q 54
//more exotic formats
#define FORMAT_R3_G3_B2 55
#define FORMAT_RGB4 56
#define FORMAT_RGBA4 57
#define FORMAT_RGB5 58
#define FORMAT_RGB5_A1 59
#define FORMAT_RGB10 60
#define FORMAT_RGB10_A2 61
#define FORMAT_RGB10_A2Q 62
#define FORMAT_RGB12 63
#define FORMAT_RGBA12 64
#define FORMAT_R11F_G11F_B10F 65
#define FORMAT_RGB9_E5 66
#define FORMAT_SRGB8 67
#define FORMAT_SRGBA8 68
//compressed formats
#define FORMAT_COMPRESSED_R 70
#define FORMAT_COMPRESSED_RG 71
#define FORMAT_COMPRESSED_RGB 72
#define FORMAT_COMPRESSED_RGBA 73
#define FORMAT_COMPRESSED_SRGB 74
#define FORMAT_COMPRESSED_SRGBA 75
#define FORMAT_COMPRESSED_R_RGTC1 76
#define FORMAT_COMPRESSED_SIGNED_R_RGTC1 77
#define FORMAT_COMPRESSED_RG_RGTC2 78
#define FORMAT_COMPRESSED_SIGNED_RG_RGTC2 79
#define FORMAT_COMPRESSED_RGB_S3TC_DXT1 80
#define FORMAT_COMPRESSED_RGBA_S3TC_DXT1 81
#define FORMAT_COMPRESSED_RGBA_S3TC_DXT3 82
#define FORMAT_COMPRESSED_RGBA_S3TC_DXT5 83

#define COMPONENTS_DEPTH 0
#define COMPONENTS_STENCIL 1
#define COMPONENTS_DEPTH_STENCIL 2
#define COMPONENTS_RED 3
#define COMPONENTS_GREEN 4
#define COMPONENTS_BLUE 5
#define COMPONENTS_RG 6
#define COMPONENTS_RGB 7
#define COMPONENTS_RGBA 8
#define COMPONENTS_RED_INTEGER 9
#define COMPONENTS_GREEN_INTEGER 10
#define COMPONENTS_BLUE_INTEGER 11
#define COMPONENTS_RG_INTEGER 12
#define COMPONENTS_RGB_INTEGER 13
#define COMPONENTS_RGBA_INTEGER 14

#define ATTACHMENT_DEPTH 0
#define ATTACHMENT_STENCIL 1
#define ATTACHMENT_DEPTH_STENCIL 2
#define ATTACHMENT_COLOR 3

#define FRAME_BUFFER_DRAW 0
#define FRAME_BUFFER_READ 1
#define FRAME_BUFFER_DRAW_READ 2

#define FRAME_BUFFER_COMPLETE 0
#define FRAME_BUFFER_UNDEFINED 1
#define FRAME_BUFFER_INCOMPLETE_ATTACHMENT 2
#define FRAME_BUFFER_INCOMPLETE_MISSING_ATTACHMENT 3
#define FRAME_BUFFER_INCOMPLETE_DRAW_BUFFER 4
#define FRAME_BUFFER_INCOMPLETE_READ_BUFFER 5
#define FRAME_BUFFER_INCOMPLETE_MULTISAMPLE 6
#define FRAME_BUFFER_INCOMPLETE_LAYER_TARGETS 7
#define FRAME_BUFFER_UNSUPPORTED 8

#define TEXTURE_1D 0
#define TEXTURE_2D 1
#define TEXTURE_3D 2
#define TEXTURE_CUBE 3
#define TEXTURE_BUFFER 4
#define TEXTURE_1D_ARRAY 5
#define TEXTURE_2D_ARRAY 6
#define TEXTURE_2D_MULTISAMPLE 7
#define TEXTURE_2D_MULTISAMPLE_ARRAY 8

#define TEXTURE_CUBE_MAP_POSITIVE_X 0
#define TEXTURE_CUBE_MAP_NEGATIVE_X 1
#define TEXTURE_CUBE_MAP_POSITIVE_Y 2
#define TEXTURE_CUBE_MAP_NEGATIVE_Y 3
#define TEXTURE_CUBE_MAP_POSITIVE_Z 4
#define TEXTURE_CUBE_MAP_NEGATIVE_Z 5

#define FILTER_NEAREST 0
#define FILTER_LINEAR 1
#define FILTER_NEAREST_MIPMAP_NEAREST 2
#define FILTER_LINEAR_MIPMAP_NEAREST 3
#define FILTER_NEAREST_MIPMAP_LINEAR 4
#define FILTER_LINEAR_MIPMAP_LINEAR 5

#define WRAP_REPEAT 0
#define WRAP_MIRRORED_REPEAT 1
#define WRAP_CLAMP_TO_EDGE 2
#define WRAP_CLAMP_TO_BORDER 3

#define SWIZZLE_ZERO 0
#define SWIZZLE_ONE 1
#define SWIZZLE_RED 2
#define SWIZZLE_GREEN 3
#define SWIZZLE_BLUE 4
#define SWIZZLE_ALPHA 5

#define TEXTURE_PARAMETER_WRAP_X 0
#define TEXTURE_PARAMETER_WRAP_Y 1
#define TEXTURE_PARAMETER_WRAP_Z 2
#define TEXTURE_PARAMETER_MIN_FILTER 3
#define TEXTURE_PARAMETER_MAG_FILTER 4
#define TEXTURE_PARAMETER_BORDER 5
#define TEXTURE_PARAMETER_BASE_LEVEL 6
#define TEXTURE_PARAMETER_MAX_LEVEL 7
#define TEXTURE_PARAMETER_MIN_LOD 8
#define TEXTURE_PARAMETER_MAX_LOD 9
#define TEXTURE_PARAMETER_MAX_ANISOTROPY 10

#define TYPE_BYTE 0
#define TYPE_DOUBLE 1
#define TYPE_QUADRO 2
#define TYPE_TINY 3
#define TYPE_SHORT 4
#define TYPE_LONG 5
#define TYPE_FLOAT 6
#define TYPE_BYTE_3_3_2 7
#define TYPE_DOUBLE_4_4_4_4 8
#define TYPE_DOUBLE_5_5_5_1 9
#define TYPE_QUADRO_8_8_8_8 10
#define TYPE_QUADRO_10_10_10_2 11
#define TYPE_QUADRO_24_8 12
#define TYPE_FLOAT_32_QUADRO_24_8 13

#define BUFFER_ARRAY 0
#define BUFFER_ELEMENT_ARRAY 1
#define BUFFER_COPY_WRITE 2
#define BUFFER_COPY_READ 3
#define BUFFER_PIXEL_PACK 4
#define BUFFER_PIXEL_UNPACK 5
#define BUFFER_TEXTURE 6
#define BUFFER_UNIFORM 7

#define USAGE_STATIC_DRAW 0
#define USAGE_STATIC_READ 1
#define USAGE_STATIC_COPY 2
#define USAGE_DYNAMIC_DRAW 3
#define USAGE_DYNAMIC_READ 4
#define USAGE_DYNAMIC_COPY 5
#define USAGE_STREAM_DRAW 6
#define USAGE_STREAM_READ 7
#define USAGE_STREAM_COPY 8

#define ACCESS_WRITE_ONLY 0
#define ACCESS_READ_ONLY 1
#define ACCESS_WRITE_READ 2

#define PRIMITIVE_POINTS 0
#define PRIMITIVE_LINES 1
#define PRIMITIVE_LINE_LOOP 2
#define PRIMITIVE_LINE_STRIP 3
#define PRIMITIVE_TRIANGLES 4
#define PRIMITIVE_TRIANGLE_STRIP 5
#define PRIMITIVE_TRIANGLE_FAN 6

#define BUFFER_FLAG_DEPTH 0x1
#define BUFFER_FLAG_STENCIL 0x2
#define BUFFER_FLAG_COLOR 0x4

#define POLYGON_FILL 0
#define POLYGON_WIREFRAME 1
#define POLYGON_POINT 2

#define LOGIC_CLEAR 0
#define LOGIC_SET 1
#define LOGIC_COPY 2
#define LOGIC_COPY_INVERTED 3
#define LOGIC_NOOP 4
#define LOGIC_INVERT 5
#define LOGIC_AND 6
#define LOGIC_NAND 7
#define LOGIC_OR 8
#define LOGIC_NOR 9
#define LOGIC_XOR 10
#define LOGIC_EQUIV 11
#define LOGIC_AND_REVERSE 12
#define LOGIC_AND_INVERTED 13
#define LOGIC_OR_REVERSE 14
#define LOGIC_OR_INVERTED 15

#define PIXEL_PACK_SWAP_BYTES 0
#define PIXEL_PACK_LSB_FIRST 1
#define PIXEL_PACK_ROW_LENGTH 2
#define PIXEL_PACK_IMAGE_HEIGHT 3
#define PIXEL_PACK_SKIP_PIXELS 4
#define PIXEL_PACK_SKIP_ROWS 5
#define PIXEL_PACK_SKIP_IMAGES 6
#define PIXEL_PACK_ALIGNMENT 7
#define PIXEL_UNPACK_SWAP_BYTES 8
#define PIXEL_UNPACK_LSB_FIRST 9
#define PIXEL_UNPACK_ROW_LENGTH 10
#define PIXEL_UNPACK_IMAGE_HEIGHT 11
#define PIXEL_UNPACK_SKIP_PIXELS 12
#define PIXEL_UNPACK_SKIP_ROWS 13
#define PIXEL_UNPACK_SKIP_IMAGES 14
#define PIXEL_UNPACK_ALIGNMENT 15

#define AUDIO_FORMAT_BYTE 0
#define AUDIO_FORMAT_DOUBLE 1
#define AUDIO_FORMAT_QUADRO 2
#define AUDIO_FORMAT_TINY 3
#define AUDIO_FORMAT_SHORT 4
#define AUDIO_FORMAT_LONG 5
#define AUDIO_FORMAT_FLOAT 6

#define AUDIO_STREAM_WAV 0
#define AUDIO_STREAM_FLAC 1
#define AUDIO_STREAM_OGG 2

#define NETWORK_TCP 0x1
#define NETWORK_UDP 0x2
#define NETWORK_IP4 0x4
#define NETWORK_IP6 0x8
#define NETWORK_INVALID_SOCKET 0xffffffffffffffff;
