#include <SDL2/SDL.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "definitions.h"
#include "simple_string.h"
#ifdef LINUX_OS
	#include <sys/types.h>
	#include <sys/stat.h>
	#include <sys/socket.h>
	#include <sys/epoll.h>
	#include <fcntl.h>
	#include <unistd.h>
	#include <dirent.h>
	#include <netdb.h>
	#include <arpa/inet.h>
	#include <netinet/in.h>
#endif
#ifdef WINDOWS_OS
	#include <winsock2.h>
	#include <ws2tcpip.h>
	#define _WINSOCKAPI_ 
	#include <windows.h>
	const char * inet_ntop(int af, const void *src, char *dst, size_t size);
#endif
#include "file_io.h"
#include "image_io.h"
#include "audio_io.h"
#include "system.h"
#include "graphics.h"
#include "enums.h"
#include "glad.h"
#include "math.h"
#include "file_io.c"
#include "image_io.c"
#include "audio_io.c"
#include "system.c"
#include "glad.c"
#include "math.c"
