#define MAX_TEMP_SIZE 0x4000
char temporary_buffer[MAX_TEMP_SIZE];
int temporary_pos;
typedef struct String
{
	char* data;
	inta length;
} String;
static String empty_string()
{
	String s;
	s.data = NULL;
	s.length = 0;
	return s;
}
static String make_string_c(const char* literal)
{
	String s;
	s.length = 0;
	s.data = (char*)literal;
	while(literal[s.length] != '\0')
		s.length++;
	return s;
}
static String make_string(char* literal, inta len)
{
	String s;
	s.data = literal;
	s.length = len;
	return s;
}
static byte string_equals(String a, String b)
{
	if(a.length != b.length)
		return false;
	for(int i = 0; i < a.length; i++)
		if(a.data[i] != b.data[i])
			return false;
	return true;
}
static byte string_starts(String a, String b)
{
	if(a.length < b.length)
		return false;
	for(int i = 0; i < b.length; i++)
		if(a.data[i] != b.data[i])
			return false;
	return true;
}
static String string_find_extension(String s)
{
	int i;
	for(i = s.length-1; i >= 0; i--)
	{
		if(s.data[i] == '.')
		{
			i++;
			break;
		}
	}
	if(i == 0)
		return empty_string();
	return make_string(&s.data[i], s.length-i);
}
static String concat(String a, String b)
{
	if(temporary_pos + a.length + b.length > MAX_TEMP_SIZE)
		temporary_pos = 0;
	char* m = &temporary_buffer[temporary_pos];
	if(a.length > 0)
		memcpy(m, a.data, a.length);
	if(b.length > 0)
		memcpy(&m[a.length], b.data, b.length);
	String r;
	r.data = m;
	r.length = a.length + b.length;
	temporary_pos += r.length;
	return r;
}
static void append_character(String* a, char c)
{
	if(temporary_pos + a->length + 1 > MAX_TEMP_SIZE)
		temporary_pos = 0;
	char* m = &temporary_buffer[temporary_pos];
	if(a->length > 0) memcpy(m, a->data, a->length);
	m[a->length] = c;
	a->data = m;
	a->length++;
	temporary_pos += a->length;
}
static const char* to_cstr(String s)
{
	append_character(&s, '\0');
	return s.data;
}
